﻿using System.Windows.Forms;

namespace CM1620_Terminal
{
    public partial class VoltageCalibrationForm : Form
    {
        public SmartLink smartLinks = null;
        public static VoltageCalibrationForm voltageCalibrationForm;

        private string STRING_PREFIX = "#calibrate";
        const string STRING_DELIM = " ";
        private string STRING_SUFFIX = "\n\r";

        public VoltageCalibrationForm(SmartLink smartLink)
        {
            smartLinks = smartLink;
            voltageCalibrationForm = this;
            InitializeComponent();
            promptLabel.Text = "--";
        }

        public void VoltageUIUpdate()
        {
            string[] balancePortVoltageArray = (string[])smartLinks.balancePortVoltageList[0];
            inputVoltageLabel.Text = smartLinks.inputVoltageList[0];
            outputVoltageLabelLabel.Text = smartLinks.outputVoltageList[0];
            cH1Label.Text = balancePortVoltageArray[0] + "V";
            cH2Label.Text = balancePortVoltageArray[1] + "V";
            cH3Label.Text = balancePortVoltageArray[2] + "V";
            cH4Label.Text = balancePortVoltageArray[3] + "V";
            cH5Label.Text = balancePortVoltageArray[4] + "V";
            cH6Label.Text = balancePortVoltageArray[5] + "V";
            cH7Label.Text = balancePortVoltageArray[6] + "V";
            cH8Label.Text = balancePortVoltageArray[7] + "V";
            cH9Label.Text = balancePortVoltageArray[8] + "V";
            cH10Label.Text = balancePortVoltageArray[9] + "V";
            cH11Label.Text = balancePortVoltageArray[10] + "V";
            cH12Label.Text = balancePortVoltageArray[11] + "V";
            cH13Label.Text = balancePortVoltageArray[12] + "V";
            cH14Label.Text = balancePortVoltageArray[13] + "V";
            cH15Label.Text = balancePortVoltageArray[14] + "V";
            cH16Label.Text = balancePortVoltageArray[15] + "V";
        }

        private void CalibrateButton_Click(object sender, System.EventArgs e)
        {
            promptLabel.Text = "--";
            string getDate = STRING_PREFIX + STRING_DELIM
                    + inputVoltageTextBox.Text + STRING_DELIM
                    + outputVoltageLabelLabel.Text + STRING_DELIM
                    + cH1TextBox.Text + STRING_DELIM
                    + cH2TextBox.Text + STRING_DELIM
                    + cH3TextBox.Text + STRING_DELIM
                    + cH4TextBox.Text + STRING_DELIM
                    + cH5TextBox.Text + STRING_DELIM
                    + cH6TextBox.Text + STRING_DELIM
                    + cH7TextBox.Text + STRING_DELIM
                    + cH8TextBox.Text + STRING_DELIM
                    + cH9TextBox.Text + STRING_DELIM
                    + cH10TextBox.Text + STRING_DELIM
                    + cH11TextBox.Text + STRING_DELIM
                    + cH12TextBox.Text + STRING_DELIM
                    + cH13TextBox.Text + STRING_DELIM
                    + cH14TextBox.Text + STRING_DELIM
                    + cH15TextBox.Text + STRING_DELIM
                    + cH16TextBox.Text + STRING_SUFFIX;
            smartLinks.userTaskData = getDate.ToCharArray();
            smartLinks.VoltageCalibrationCmd();
        }

        public void PromptLabelUIUpdate(string prompt)
        {
            promptLabel.Text = prompt;
        }

        private void VoltageCalibrationForm_Load(object sender, System.EventArgs e)
        {

        }
    }
}
